/*
 * PM - Line follower
 * 
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


void ADC_init(void)
{
	ADMUX = 0;
	ADMUX = (1 << REFS0);
	
	ADCSRA = (1 << ADEN) | (7 << ADPS0);
}


int ADC_get(uint8_t channel)
{

	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC));

	return ADC;
}

void pwm_init(void)
{
	TCCR1A |= (1 << WGM11) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS12);
	
	ICR1 = 512;
	// PWM default cu factor umplere 50%
	OCR1A = 256;
	OCR1B = 256;
}


int main(void)
{
	/* Initializari */
	
	ADC_init();
	pwm_init();
	
	DDRA = 0;
	PORTA = 255;
	DDRD = (1 << PD7) | (1 << PD4) | (1 << PD5); 
	PORTD |= (1 << PD4) | (1 << PD5);
	
	DDRC = (15 << PC0);
	PORTC = (1 << PC0) | (1 << PC3);
	PORTD = 0;

	/* 
	
	PC0 - inainte roata stanga
	PC1 - inapoi roata stanga
	PC2 - inapoi roata dreapta
	PC3 - inainte roata dreapta
	
	*/
	
	//730 - senzorul detecteaza banda neagra (cu firul de la vcc placa la 5v driver!)
	
	OCR1A = 0;
	OCR1B = 0;
	_delay_ms(5000);
		
	while (1) {
		/*
		if (ADC_get(0) > 733) {
			PORTD |= (1 << PD7);
		}		
		else 
			PORTD &= ~(1 << PD7);
			
		*/
		if (ADC_get(0) > 733) {
			PORTD |= (1 << PD7);
			OCR1A = 270;
			OCR1B = 270;
		}		
		else {
			PORTD &= ~(1 << PD7);
			OCR1A = 0;
			OCR1B = 0;
		}
		
	}
	return 0;
}
